/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Sep 7, 2004, 2:39:29 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac;

import junit.extensions.jfcunit.JFCTestCase;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * Collect the testcases and testsuites from this directory and from the
 * subdirectories
 * 
 * ###########################################################################
 * ATTENTION: running the tests requires BridgeMain, KEStore and ObjectManager
 * to be launched before !!!
 * ###########################################################################
 * 
 * @author Walther Neuper Oct 1, 2004, 3:44:31 PM
 * @version 1.0
 */
public class Testall extends TestCase {

    public static Test suite() {
        System.out.println("---isac.Testall");
        TestSuite suite = new TestSuite("isac.Testall");

        //tests from this directory
        //...

        //module-tests from subdirectories
        suite.addTest(isac.bridge.Testall.suite());//requires BridgeMain to run
        suite.addTest(isac.kestore.Testall.suite());
        suite.addTest(isac.session.Testall.suite());
        suite.addTest(isac.util.Testall.suite());
        //suite.addTest(isac.gui.Testall.suite());//swingui ???

        //functional tests from isac.functest
        suite.addTest(isac.functest.Testall.suite());
        //WN050415 ???: JUnit-Hierarchy shows isac.functest's as
        //children of isac.gui.browser.example.Testall !!!???
        //because this Testall calls TestExampleBrowserPanel extends
        // __JFCTestCase__ (and not only 'extends TestCase') ???

        return suite;
    }

}