/*
 * Created on 12.07.2005
 *
 */
package isac.gui.browser.minibrowser;

import java.io.IOException;

import isac.gui.browser.minibrowser.MiniBrowser;
import isac.interfaces.IGuiToGui;
import isac.useractions.EUIElement;
import isac.useractions.IUserAction;
import isac.useractions.UserActionOnString;

import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import isac.gui.browser.BrowserFrame;
import isac.browserdialog.IBrowserDialog;
import isac.session.Session;
/**
 * @author JL
 *
 * A mock class to test the MiniBrowser.
 * Catches a HyperlinkEvent and sets a internal variable to true. 
 * 
 */
public class ProxyMock extends BrowserFrame {

	public boolean hyperlink_event_fired_ = false;
	
	public String link_ = "";
	
	public ProxyMock(IBrowserDialog dialog) {
		super(dialog ,"title");
	}
	
	/**
	 * Sets hyperlink_event_fired to true if a hyperlinkEvent is fired
	 * and updates the page in the MiniBrowser
	 * 
	 * @param hyperlink_event
	 * @throws IOException
	 */
	public void hyperlinkUpdate(HyperlinkEvent hyperlink_event){
		hyperlink_event_fired_ = true;
		MiniBrowser mini_browser =  (MiniBrowser) hyperlink_event.getSource();
			mini_browser.setPage(hyperlink_event.getURL());
		
		link_ = hyperlink_event.getURL().toString();
	}

	/* (non-Javadoc)
	 * @see isac.interfaces.IGuiToGui#notifyUserAction(isac.useractions.IUserAction)
	 */
	public void notifyUserAction(IUserAction action) {
		hyperlink_event_fired_ = true;
		switch(action.getActionID()) {
			case UI_MINIBROWSER_LINK: {
				link_ = ((UserActionOnString)action).getString();
				break;
			}
		}
	}

}
