/**
 * 
 */
package isac.gui.calcheadviews;

import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.JFrame;

import isac.util.formulae.CalcHead;
import isac.util.formulae.CalcHeadSimpleID;
import isac.util.formulae.Formula;
import isac.util.formulae.HierarchyKey;
import isac.util.formulae.Match;
import isac.util.formulae.Model;
import isac.util.formulae.ModelItem;
import isac.util.formulae.ModelItemList;
import isac.util.formulae.Position;
import isac.util.formulae.ProblemID;
import isac.util.formulae.Specification;

/**
 * @author Manuel Koschuch
 * 
 */
public class TestModelPanel {

	private CalcHead setupEquationCalcHead() {
		CalcHead ch = new CalcHead();

		ch.setStatusString("correct");
		// ----------------------the headline
		Formula f = new Formula();
		f.setText("solve (x + 1 = 2, x)");
		ch.setHeadLine(f);

		// ----------------------the model
		Model m = new Model();
		ModelItemList its;
		ModelItem it1 = new ModelItem(), it2 = new ModelItem();

		it1.setText("equality (x+1=2)");
		it1.setItemStatus("correct");
		it2.setText("solfeFor x");
		it2.setItemStatus("false");
		its = new ModelItemList();
		its.addItem(it1);
		its.addItem(it2);
		m.setGiven(its);// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

		ModelItem it3 = new ModelItem(), it4 = new ModelItem();

		it3.setText("matches (?a = ?b) (x+1=2)");
		it3.setItemStatus("correct");
		its = new ModelItemList();
		its.addItem(it3);
		m.setWhere(its);// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

		it4.setText("solutions L");
		it4.setItemStatus("correct");
		its = new ModelItemList();
		its.addItem(it4);
		m.setFind(its);// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		ch.setModel(m);

		// ----------------------
		ch.setBelongsTo("Pbl");

		// ----------------------the specification
		Specification s = new Specification();
		CalcHeadSimpleID id;

		id = new CalcHeadSimpleID();
		id.setID("Test.thy");
		s.setTheory(id);

		HierarchyKey idl = new ProblemID();
		idl.addString("sqroot-test");
		idl.addString("univariate");
		idl.addString("equation");
		idl.addString("test");
		s.setProblem(idl);

		idl = new HierarchyKey();
		idl.addString("Test");
		idl.addString("squ-equ-test-subpbl1");
		s.setMethod(idl);

		ch.setSpecification(s);

		Position p = new Position();

		ch.setPosition(p);

		ch.setViewstyle(CalcHead.VIEWSTYLE_FULL);

		return ch;
	}

	TestModelPanel() {
		ResourceBundle res_bundle = ResourceBundle.getBundle("CalcHeadPanel",
				Locale.getDefault());
		CalcHead ch = setupEquationCalcHead();
		Match match = new Match(null, null, ch.getHeadLine(), ch.getModel());
		JFrame frame = new JFrame("Modelpanel Test");
		ModelPanel panel = new ModelPanel(match, res_bundle);
		panel.fillTextFieldsFromMatch(match);
		frame.getContentPane().add(panel);
		panel.setVisible(true);
		frame.pack();
		frame.setVisible(true);
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		TestModelPanel test = new TestModelPanel();

	}

}
