package isac.gui.treetable;

import isac.util.formulae.CalcFormula;
import isac.util.formulae.Position;
import junit.framework.TestCase;

public class CalcHierarchyTest extends TestCase {

	public void testFindParent() {
		CalcModelHierarchy cmh = new CalcModelHierarchy();
		
		Position p1 = new Position();
		p1.setKind("Pbl");
		
		Position p2 = new Position();
		p2.setKind("Frm");
		p2.addInt("1");		
		
		Position p3 = new Position();
		p3.setKind("Res");
		p3.addInt("1");
		
		Position p4 = new Position();
		p4.setKind("Pbl");
		p4.addInt("2");
		
		Position p5 = new Position();
		p5.setKind("Frm");
		p5.addInt("2");
		p5.addInt("1");
		
		Position p6 = new Position();
		p6.setKind("Res");
		p6.addInt("2");
		p6.addInt("1");
		
		Position p7 = new Position();
		p7.setKind("Frm");
		p7.addInt("3");
		p7.addInt("3");
		p7.addInt("3");
		p7.addInt("3");

		Position p8 = new Position();
		p8.setKind("Pbl");
		p8.addInt("2");
		p8.addInt("1");

		Position p9 = new Position();
		p9.setKind("Frm");
		p9.addInt("2");
		p9.addInt("1");
		p9.addInt("2");

		Position p10 = new Position();
		p10.setKind("Pbl");
		p10.addInt("2");
		p10.addInt("1");
		p10.addInt("2");
		p10.addInt("2");
		
		Position p11 = new Position();
		p11.setKind("Pbl");
		p11.addInt("2");
		p11.addInt("1");
		p11.addInt("2");
		p11.addInt("1");
		
		CalcFormula cf1 = new CalcFormula();
		cf1.setPosition(p1);
		assertNotNull( cmh.insert(cf1) );
		assertNull( cmh.insert(cf1) );
		
		CalcFormula cf2 = new CalcFormula();
		cf2.setPosition(p2);
		assertNotNull( cmh.insert(cf2) );
		
		CalcFormula cf3 = new CalcFormula();
		cf3.setPosition(p3);
		assertNotNull( cmh.insert(cf3) );

		CalcFormula cf4 = new CalcFormula();
		cf4.setPosition(p4);
		assertNotNull( cmh.insert(cf4) );
		
		CalcFormula cf5 = new CalcFormula();
		cf5.setPosition(p5);
		assertNotNull( cmh.insert(cf5) );

		CalcFormula cf6 = new CalcFormula();
		cf6.setPosition(p6);
		assertNotNull( cmh.insert(cf6) );	
		
		CalcFormula cf7 = new CalcFormula(); // [3,3,3,3],Frm - but the deapest level is [2,1]
		cf7.setPosition(p7);
		assertNull( cmh.insert(cf7) );
		
		CalcFormula cf8 = new CalcFormula(); // [2,1],Pbl - but [2,1],Frm already exists
		cf8.setPosition(p8);
		assertNull( cmh.insert(cf8) );
		
		CalcFormula cf9 = new CalcFormula();
		cf9.setPosition(p9);
		assertNotNull( cmh.insert(cf9) );
		
		CalcFormula cf10 = new CalcFormula();
		cf10.setPosition(p10);
		assertNotNull( cmh.insert(cf10) );
		
		CalcFormula cf11 = new CalcFormula();
		cf11.setPosition(p11);
		assertNotNull( cmh.insert(cf11) );

		Position p12 = new Position();
		p12.setKind("Pbl");
		for( int i = 1; i < 50; i++ )
		{
			p12.addInt("7");
			CalcFormula cfloop = new CalcFormula();
			cfloop.setPosition((Position)p12.clone());
			assertNotNull( cmh.insert(cfloop) );			
		}
			
	}
}
