/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Sep 7, 2004, 11:59:12 AM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.kestore;

import java.util.Vector;

import junit.framework.TestCase;

/**
 * @author Walther Neuper Sep 7, 2004, 11:59:12 AM
 * 
 * @see isac.util.parser.TestFormalizationDigest for how the xml-data are parsed
 *      into a Formalization object
 */
public class TestKEStoreServices extends TestCase {

    public void testLoadContentMinisubpbl() {
        System.out
                .println("---BEGIN isac.kestore.TestKEStoreServices#testLoadContentMinisubpbl");

        KEStoreServices ks = new KEStoreServices("isac/xmldata");
        Vector vec = ks.loadContent("exp", "exp_IsacCore_Tests_1b.xml");

        System.out.println("vec = " + vec.firstElement().toString());
        String test = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"// ---------
                + "<EXAMPLE>\n"// ----------------------------------------
                + "  <GUH> exp_IsacCore_Tests_1b </GUH>\n"// --------------------
                + "  <STRINGLIST>\n"// ----------------------------------------
                + "    <STRING> IsacCore </STRING>\n"
                + "    <STRING> Tests </STRING>\n"// ----------------------------
                + "    <STRING> miniscript_with_mini-subpbl </STRING>\n"
                + "  </STRINGLIST>\n"// ----------------------------------------
                + "  <META> </META>\n"// ----------------------------------------
                + "  <NO> 1b </NO>\n"// ----------------------------------------
                + "  <DESCRIPTION>\n"// ----------------------------------------
                + "<a href=\"exp_IsacCore_Tests_1b.html#COMMAND_EXEC_EXAMPLE#exp_IsacCore_Tests_1b.xml\">start</a>\n"
                + "<p>Solve the equation x+1=2 in x.</p>\n"// --------------------
                + "<p>This equation is not in a normal-form which can be recognized by the hierarchy of equation-types as implemented. \n"
                + "Thus the equation is being normalized first, the normalized equation is recognized as a linear equation \n"
                + "and solved accordingly (acutally an example, of how machines work --- without any intuition even for such simple equations !).</p>\n"
                + "  </DESCRIPTION>\n"// ----------------------------------------
                + "  <FORMALIZATION> \n"// ----------------------------------------
                + "    <VARIANT>\n"// ----------------------------------------
                + "      <TERMLIST>\n"// ----------------------------------------
                + "  	<MATHML>\n"// ----------------------------------------
                + "  	  <ISA> equality (x+1=2) </ISA>\n"// ---------------------
                + "  	</MATHML>\n"// ----------------------------------------
                + "  	<MATHML>\n"// ----------------------------------------
                + "  	  <ISA> solveFor x </ISA>\n"// --------------------------
                + "  	</MATHML>\n"// ----------------------------------------
                + "  	<MATHML>\n"// ----------------------------------------
                + "  	  <ISA> solutions L </ISA>\n"// --------------------------
                + "  	</MATHML>\n"// ----------------------------------------
                + "      </TERMLIST>\n"// ----------------------------------------
                + "      <SPECIFICATION>\n"// ------------------------------------
                + "  	<THEORY> Test.thy </THEORY>\n"// -------------------------
                + "  	<PROBLEM>\n"// ----------------------------------------
                + "  	  <KEY>\n"// ----------------------------------------
                + "  	    <ID> sqroot-test </ID>\n"// -------------------------
                + "  	    <ID> univariate </ID>\n"// --------------------------
                + "  	    <ID> equation </ID>\n"// ---------------------------
                + "  	    <ID> test </ID>\n"// -------------------------------
                + "  	  </KEY>\n"// ----------------------------------------
                + "  	</PROBLEM>\n"// ----------------------------------------
                + "  	<METHOD>\n"// ----------------------------------------
                + "  	  <KEY>\n"// ----------------------------------------
                + "  	    <ID> Test </ID>\n"// -------------------------------
                + "  	    <ID> squ-equ-test-subpbl1 </ID>\n"// ---------------
                + "  	  </KEY>\n"// ----------------------------------------
                + "  	</METHOD>\n"// ----------------------------------------
                + "      </SPECIFICATION>\n"// ---------------------------------
                + "      <HIDE> </HIDE>\n"// -----------------------------------
                + "      <DETAIL> </DETAIL>\n"// -------------------------------
                + "    </VARIANT> \n"// ----------------------------------------
                + "  </FORMALIZATION>\n"// -------------------------------------
                + "</EXAMPLE>";// ----------------------------------------
        String s1 = test;
        String s2 = vec.firstElement().toString();
        char c1, c2;
        for (int i = 0; i < s2.length(); i++) {
            c1 = s1.charAt(i);
            c2 = s2.charAt(i);
            if (c1 == c2) {
                System.out.println("equal " + c1 + ' ' + ' ' + c2);
            } else {
                System.out.println("UNequ " + c1 + ' ' + ' ' + c2);
            }
        }
        assertEquals("KEStoreServices.loadContent: xml ---> Vector", test, vec
                .firstElement().toString());
        System.out
                .println("---END isac.kestore.TestKEStoreServices#testLoadContentMinisubpbl");
    }

    public void testLoadPage() {
        System.out
                .println("---BEGIN isac.kestore.TestKEStoreServices#testLoadPage");

        KEStoreServices ks = new KEStoreServices("isac/xmldata");
        Vector vec = ks.loadContent("exp", "exp_Why_learn_Math_I.xml");
        // TOOODO AG? weaken the xml/html constraints of XML-rpc ?

        System.out
                .println("---END isac.kestore.TestKEStoreServices#testLoadPage");
    }
}