/*
 * @author Georg Kompacher, member of the ISAC-team, 
 * Copyright (c) 2006 by Georg Kompacher
 * created 18.07.2006 13:32:29
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.kestore;

import isac.util.formulae.HierarchyKey;
import isac.util.parser.HierarchyKeyParser;

import java.io.IOException;
import java.net.MalformedURLException;
import java.util.Vector;

import junit.framework.TestCase;

import org.apache.xmlrpc.XmlRpcClient;
import org.apache.xmlrpc.XmlRpcException;

public class TestLoadContent extends TestCase {

	public void testLoadContent() {
		System.out
				.println("---BEGIN isac.kestore.TestLoadContent#testLoadContent");
		
		Vector<String> parameter = new Vector<String>();
		parameter.add("thy");
		parameter.add("thy_scri_ListG-thm-butlast_Cons.xml");
		XmlRpcClient client_ = null;
		Vector result = null;
		try {
			client_ = new XmlRpcClient("http://localhost:1030");
			result = (Vector) client_.execute("KEStore.loadContent", parameter);
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (XmlRpcException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        
		HierarchyKeyParser hkp = new HierarchyKeyParser("isac/src/xml/ke_store.dtd");
		hkp.setValidating(true);
		HierarchyKey hk = hkp.parse(result.firstElement().toString());
		
		String valid_string = "<KEY>\n"
		                    + "<ID>IsacScripts</ID>\n"
		                    + "<ID>ListG</ID>\n"
                            + "<ID>Theorems</ID>\n"
                            + "<ID>butlast_Cons</ID>\n"
                            + "</KEY>\n";
		
		assertEquals(hk.toString(), valid_string);
	}
}