/*
 * Created on Aug 27, 2004
 */
package isac.util.parser;

import isac.util.ResponseWrapper;
import isac.util.tactics.Rewrite;
import isac.util.tactics.RewriteInst;

/**
 * @author rgradish, transferred by WN040830
 */
public class RGtestXMLParserDigest {

	public static void main(String[] args) {
		if (args.length != 1) {
			System.out.println("Specify Path to dtd_ as Parameter");
		}
		XMLParserDigest d = new XMLParserDigest(args[0]);
		System.out
				.println(d
						.parse("<ISAC><NEXTTAC><CALCID> 1 </CALCID><REWRITESETTACTIC name=\"Rewrite_Set\"><RULESET> Test_simplify</RULESET></REWRITESETTACTIC></NEXTTAC></ISAC>"));
		System.out
				.println(d
						.parse("<ISAC><NEXTTAC><CALCID> 1 </CALCID><SIMPLETACTIC name=\"Add_Given\"><MATHML><ISA>equality (1 + -1 * 2 + x = 0)</ISA></MATHML></SIMPLETACTIC></NEXTTAC></ISAC>"));

		//Testing Rewrite Tactic
		System.out.println("----Now testing Rewrite----");
		ResponseWrapper rw = d
				.parse("<ISAC><REWRITETACTIC name=\"Rewrite\"><THEOREM><ID> all_left </ID><FORMULA><MATHML><ISA> ~ ?b =!= 0 ==> (?a = ?b) = (?a - ?b = 0) </ISA></MATHML></FORMULA></THEOREM></REWRITETACTIC></ISAC>");
		Rewrite r = ((Rewrite) rw.getResponse());
		System.out.println(r.getName());
		System.out.println(r.getTheorem().getId());
		System.out.println(r.getTheorem().getFormula());
		System.out.println(r.toSMLString());

		//Testing RewriteInst Tactic
		System.out.println("----Now testing RewriteInst----");
		rw = d
				.parse("<ISAC><REWRITEINSTTACTIC name=\"Rewrite_Inst\"><SUBSTITUTION><PAIR><VARIABLE><MATHML><ISA> bdv </ISA></MATHML></VARIABLE>       <VALUE><MATHML><ISA> x </ISA></MATHML></VALUE></PAIR></SUBSTITUTION><THEOREM><ID> all_left </ID><FORMULA><MATHML>          <ISA> ~ ?b =!= 0 ==> (?a = ?b) = (?a - ?b = 0) </ISA></MATHML></FORMULA></THEOREM></REWRITEINSTTACTIC></ISAC>");
		RewriteInst ri = ((RewriteInst) rw.getResponse());
		System.out.println(ri.getName());
		System.out.println(ri.getVariable());
		System.out.println(ri.getValue());
		System.out.println(ri.getTheorem().getId());
		System.out.println(ri.getTheorem().getFormula());
		System.out.println(ri.toSMLString());

		System.out.println(d.parse("<ISAC></ISAC>"));
		System.out.println("done");
	};

}