/*
 * @author Georg Kompacher, member of the ISAC-team, 
 * Copyright (c) 2006 by Georg Kompacher
 * created Jul 11, 2006 14:07:25 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.browserdialog;

import isac.util.formulae.Context;

/**
 * @author Georg Kompacher
 * 
 * This interface is responsible for the presentation of a context in the right
 * BrowserFrame. It is implemented in the BrowserDialog.
 * 
 * @see isac.browserdialog.BrowserDialog
 */
public interface IContextPresenter {

	/**
	 * This method is implemeted by the derived classes of the
	 * BrowserDialog-class. The method will send an UIAction to the Browser.
	 */
	void presentContext(Context context);

}
