/****************************************************************** 
* Copyright (c) 2004, Alois Kirchsteiger, Student of 
* Software Engineering at FH-Hagenberg, Austria. 
* Project member of the isac team at the Institute for 
* Software-Technologie, Graz University of Technology, Austria. 
* 
* Use is subject to license terms.
******************************************************************/

package isac.gui;

import java.io.Serializable;

/**
 * @author Alois Kirchsteiger
 */
public class LoginEvent implements Serializable {

	static final long serialVersionUID = 3145149672258700584L;
	
	/**Constants to specify the event type */
	public static final int LOGIN_TYPE_TRY_TO_LOGIN = 0;
	public static final int LOGIN_TYPE_EXIT = 1;
	
	private String username;
	private String password;
	private int type;
	
	public LoginEvent(int type) {
		this.type = type;
	}
	
	public LoginEvent(int type, String username, String password) {
		this.type = type;
		this.username = username;
		this.password = password;
	}
	
	public int getType() {
		return type;
	}
	
	public String getPassword() {
		return password;
	}
	public String getUsername() {
		return username;
	}
}
