package isac.gui;

import isac.useractions.IUIAction;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;

public class WorksheetPopupHandler {
	
    protected Vector<IUIAction>	actions_;
    protected JPopupMenu 	menu_;
    
    protected HashMap<IUIAction, String>		actions_to_labels_; // Assumption : Only one label per action.  
    
    public WorksheetPopupHandler() {
    	actions_ = new Vector<IUIAction>();
    	actions_to_labels_ = new HashMap<IUIAction, String>();
    	menu_ = null;    	
    }
    
    public void addAction( IUIAction dynAction ) {
    	if( actions_to_labels_.containsValue( dynAction.getLabel() ) )
    		return;
    	
    	actions_to_labels_.put( dynAction, dynAction.getLabel() );		
		actions_.add( dynAction );
    }

    public void addAction( IUIAction dynAction, String label ) {
    	if( actions_to_labels_.containsValue( label ) )
    		return;
    	
    	actions_to_labels_.put( dynAction, label );		
		actions_.add( dynAction );
    }
    
    public JPopupMenu buildContextMenu( Worksheet ws ) {
    	menu_ = new JPopupMenu();
    	
		// get the popup menus that are equivalet for all calc elements
		Iterator iterator = actions_.iterator();
		
		while (iterator.hasNext()) {
			IUIAction action = (IUIAction) iterator.next();
			String label = (String) actions_to_labels_.get( action );
			JMenuItem menu_item = new JMenuItem(label);
			ws.registerActionWithListener( menu_item, action );
			menu_item.addActionListener( ws );
			menu_.add(menu_item);
		}
		
		return menu_;
	}
    
    public JPopupMenu mergeContextMenu( Worksheet ws, JPopupMenu popup ) {
    	menu_ = popup;
    	
		// get the popup menus that are equivalet for all calc elements
		Iterator iterator = actions_.iterator();
		
		while (iterator.hasNext()) {
			IUIAction action = (IUIAction) iterator.next();
			String label = action.getLabel();
			JMenuItem menu_item = new JMenuItem(label);
			ws.registerActionWithListener( menu_item, action );
			menu_item.addActionListener( ws );
			menu_.add(menu_item);
		}
		
		return menu_;
    }
}
