package isac.gui.browser.minibrowser;

import java.util.HashMap;
import java.util.Vector;

import javax.swing.text.Element;
import javax.swing.text.View;
import javax.swing.text.html.HTML;
import javax.swing.text.html.HTMLEditorKit.HTMLFactory;

public class MiniBrowserViewFactory extends HTMLFactory {
	
	protected MiniBrowser parent_;
	
	protected HashMap<String, IHTMLElementRenderer>	  	  map_tag_presenter_;
	protected Vector<IHTMLElementRenderer>  	  	      tag_found_;
	
	public MiniBrowserViewFactory( MiniBrowser parent ) {
		super();
		parent_ = parent;
		map_tag_presenter_ = new HashMap<String, IHTMLElementRenderer>();
		tag_found_ = new Vector<IHTMLElementRenderer>();
	}

	public View create( Element element ) {
		
		if( element.getAttributes().getAttribute(HTML.Attribute.CLASS)== null )
			return super.create( element );
		
		if( map_tag_presenter_.containsKey( element.getAttributes().getAttribute(HTML.Attribute.CLASS).toString() ) &&	
				element.getAttributes().getAttribute(HTML.Attribute.ENDTAG)== null ) {
			IHTMLElementRenderer presenter = map_tag_presenter_.get( element.getAttributes().getAttribute(HTML.Attribute.CLASS).toString() );
			
			View render = presenter.renderElement( element );
			
			if( render != null )
				return render;
		}
				
		return super.create( element );
	}
	
	public void addElementPresenter( String tag, IHTMLElementRenderer presenter ) {
		map_tag_presenter_.put( tag.toLowerCase(), presenter );
	}
}
