package isac.gui.calcheadviews;

import isac.util.formulae.Formula;

import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * Graphical Representation of a CalcHead's HeadLine
 * 
 * @author Manuel Koschuch
 * @version $Revision
 * 
 * 
 */
public class HeadLinePanel extends JPanel {

	private static final long serialVersionUID = 1L;

	private JLabel head_line_;

	/**
	 * Creates new HeadLinePanel with given HeadLine
	 * 
	 * @param head_line
	 *            Headline to display
	 */
	public HeadLinePanel(Formula head_line) {
		head_line_ = new JLabel(head_line.toString());
		this.add(head_line_);
	}

	/**
	 * Fills HeadLinePanel from supplied HeadLine
	 * 
	 * @param head_line
	 *            HeadLine to fill Panel from
	 */

	public void fillHeadLinePanelFromFormula(Formula head_line) {
		head_line_.setText(head_line.toString());
	}

	/**
	 * Returns HeadLine
	 * 
	 * @return current HeadLine
	 * 
	 */

	public String getHeadLine() {
		return head_line_.getText();
	}

	/**
	 * Clears HeadLine
	 */

	public void reset() {
		head_line_.setText("");
	}

	/**
	 * Fills HeadLine, when used in stepwise mode
	 * 
	 * @param head_line
	 *            to fill Panel from
	 * 
	 * @deprecated was misunderstanding
	 */

	public boolean next(Formula head_line) {
		head_line_.setText(head_line.toString());
		return true;
	}

}