/****************************************************************** 
 * Copyright (c) 2003, Mario Hochreiter, Student of 
 * Software Engineering at FH-Hagenberg, Austria. 
 * Project member of the isac team at the Institute for 
 * Software-Technologie, Graz University of Technology, Austria. 
 * 
 * Use is subject to license terms.
 ******************************************************************/

package isac.gui.calcheadviews;

import java.awt.Color;

import isac.util.formulae.CalcHead;

/**
 * Defines the public methods that each <code>CalcHeadView</code> has to
 * implement
 * 
 * @author Mario Hochreiter
 * @version 1.0
 * 
 */
public interface ICalcHeadView {

	// public static final Color MODEL_ITEM_CORRECT_COLOR = Color.green;

	public static final Color MODEL_ITEM_CORRECT_COLOR = new Color(0.0f, 0.7f,
			0.0f);

	public static final Color MODEL_ITEM_INCORRECT_COLOR = Color.red;

	public static final Color MODEL_ITEM_SYNTAXERROR_COLOR = Color.pink;

	public static final Color MODEL_ITEM_INCOMPLETE_COLOR = Color.blue;

	public static final Color MODEL_ITEM_FALSE_COLOR = Color.red;

	public static final Color MODEL_ITEM_HELP_ME_COLOR = Color.green;

	public static final Color MODEL_ITEM_SUPERFLUOUS_COLOR = Color.gray;

	public static final Color MODEL_ITEM_MISSING_COLOR = Color.yellow;

	public static final int FIELD_SIZE = 25;

	/** populate the text fields with the values from the <code>CalcHead</code> */
	public void fillTextFieldsFromCalcHead(CalcHead ch);

	/**
	 * fill the supplied CalcHead from the TextFields
	 * 
	 * @param ch
	 *            CalcHead to be filled
	 */
	public void fillCalcHeadFromTextFields(CalcHead ch);

	/** reset Panel */
	public void reset();
}