/**
 * @author Andreas Griesmayer
 * Created on Oct 6, 2003
 */
package isac.session;

import isac.browserdialog.IBrowserDialog;
import isac.users.IUserManager;
import isac.wsdialog.IWorksheetDialog;

import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * @author Andreas Griesmayer
 */
public interface IObjectManager extends Remote {

    /**
     * fetch the XSessionManager of the system - multiple calls to this method
     * result in one and the same XSessionManager.
     */
    public abstract ISessionManager getSessionDialog() throws RemoteException;
    
    /**
     * fetch the UserManager of the system - multiple calls to this method
     * result in one and the same UserManager.
     */
	public abstract IUserManager getUserManager() throws RemoteException;

    /**
     * fetch the XBrowserDialog identified by <code>bdialog_id</code>
     */
    public abstract IBrowserDialog getBrowserDialog(String id) throws RemoteException;

    /**
     * fetch the WorksheetDialog identified by <code>wdialog_id</code>
     */
    //public abstract IWorksheetDialog getWorksheetDialog(String id) throws RemoteException;
}