package isac.useractions;

public enum EUIContext {

    /** the context for a whole calculation (0507 on the mainframe) */
   UI_CONTEXT_CALCULATION,

    /** for all calcelements together existing in a calculation (0507 context */
   UI_CONTEXT_CALCELEMENTS,

    /** for one specific element in a calculation (0507 added to context menu) */
   UI_CONTEXT_ONEELEMENT,

   /**
    * --------------------------------------------------------------------------------
    * Contexts used in general BrowserFrame<->Browser communication
    * --------------------------------------------------------------------------------
    */
   
   /**
    * Context for adding the buttons to the menu bar
    * and receiving UserActions generated by 
    * those buttons
    * 
    */
   UI_CONTEXT_BROWSER,
   
   /**
    * Context used for hierarchy operations 
    *  
    */
   UI_CONTEXT_HIERARCHY,

   /** 
    * To send the MiniBrowser something 
    * 
    */
   UI_CONTEXT_CONTENT,

   /**
    * --------------------------------------------------------------------------------
    * End of contexts used in general BrowserFrame<->Browser communication
    * --------------------------------------------------------------------------------
    */
   
    /** for the panel in the problem browser * */
   UI_CONTEXT_BROWSER_PANEL,
    
   UI_CONTEXT_BROWSER_MODEL_PANEL,

   UI_CONTEXT_MINIBROWSER,
    
    /**
     * not a useraction, but for technical reasons: for lauching and releasing
     * the CalcHeadPanel
     */
   UI_CONTEXT_SWITCH_PHASES,

    /** for all elements on the CalcHeadPanel */
   UI_CONTEXT_CALCHEAD,

    /** FIXME used, until UIAction and UserAction are merged */
   UI_CONTEXT_NO_CONTEXT,

    /** use this if you send something to a dialog, and you do not know
     * what kind of dialog it is
     */
   UI_CONTEXT_DIALOG,

   UI_CONTEXT_WORKSHEET,
    
   UI_CONTEXT_WINDOW_APPLICATION,
    
    
    /** 
     * NC 0606
     * To send the applicable tactics 
     *   
     */
    
   UI_CONTEXT_APPLICABLE_TACTIC;
    	
}
