/*
 * @author Alois Kirchsteigerr, Alan Krempler
 * created Jul 11, 2005 11:13:42 AM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.useractions;

import java.io.Serializable;

/**
 * A context provides for grouping of interactive elements on the gui. The
 * grouping concerns the data to be sent with <code>IUIAction</code>
 * (DialogIterator, CalcElement, etc.) as well as the location of the elements
 * (on the menu-bar, in the context-menu, etc.)
 * 
 * @see IUserAction for reverse direction (i.e. GUI --> Dialog)
 * 
 * @author Alois Kirchsteigerr, Alan Krempler
 */
public interface IUIAction extends IUIElement, Serializable {

    /**
     * The design (AK,LK) provided usage of context only in direction dialoges
     * to gui, not to in (vice versa) direction gui to dialoges.
     * 
     * @see IUIAction
     * @return An integer value describing the context of the UIElement
     */
    public EUIContext getContext();

    public EUIElement getAction();

    public String getLabel();

}