/*
 * @author Alan Krempler and Alois Kirchsteiger
 * created Jul 11, 2005 11:17:27 AM
 * 
 * Use is subject to PGPL license terms.
 */
package isac.useractions;

import isac.users.UserLanguage;
import isac.util.formulae.Position;

/**
 * @author Alan Krempler
 * @author Alois Kirchsteiger
 */
public class UIAction implements IUIAction {

    static final long serialVersionUID = 990127545268100809L;

	private EUIContext context_;

    private EUIElement action_;
    
    private Position position_;
    
    private String label_;
    
    public EUIContext getContext() {
        return context_;
    }

    public EUIElement getAction() {
        return action_;
    }
    
    public Position getPosition() {
    	return position_;
    }

    public UIAction(EUIElement action, EUIContext context, Position pos, UserLanguage language ) {
        action_ = action;
        context_ = context;
        position_ = pos;
        if( language != null )
        	label_ = language.getLabel( action );
        else
        	label_ = "Undefined";
    }
    
    public UIAction(EUIElement action, EUIContext context, UserLanguage language ) {
        action_ = action;
        context_ = context;
        position_ = null;
        if( language != null )
        	label_ = language.getLabel( action );
        else
        	label_ = "Undefined";
    }
       
    public String getLabel() {   	
    	return label_;
    	
//    	//FIXXME: find better way to support internationalization, labeling of
//        // buttons
//        switch (action_) {
//        case UI_SPECIFY_CALCULATE_ALL:
//            return "auto";//WN050803 distinguish "AUTO" during testphase
//        case UI_SPECIFY_COMPLETE_STEPWISE:
//            return "next";//WN050803 distinguish "NEXT" during testphase
//        case UI_SPECIFY_CHECK_CALCHEAD:
//            return "Check";
//        case UI_SPECIFY_COMPLETE_CALCHEAD:
//            return "Complete";
//        case UI_SPECIFY_RESET:
//            return "Reset";
//        case UI_SPECIFY_TO_SOLVE:
//            return "Start Solving";
//        case UI_SPECIFY_CLOSE_CALCHEAD:
//            return "Close";
//            
//        case UI_SOLVE_CALCULATE_ALL:
//            return "AUTO";
//        case UI_SOLVE_CALCULATE_1:
//            return "NEXT";
//        case UI_SOLVE_GET_APPLICABLE_TACTICS:
//            return "Applicable tactics";
//        case UI_SOLVE_SHOW_ASSUMPTIONS:
//            return "Assumptions";
//        case UI_SOLVE_TACTIC_APPLIED:
//            return "Tactic Applied";
//        case UI_SOLVE_SHOW_INTERMEDIATE_STEPS:
//            return "Intermediate Steps";
//        case UI_SOLVE_SHOW_CALCHEAD:
//            return "Calchead";
//            
//        case UI_BROWSER_MATCH_OFF:
//        	return "Context On->Off";
//        case UI_BROWSER_MATCH_ON:
//        	return "Context Off->On";
//        case UI_BROWSER_TO_WORKSHEET:
//        	return "To Worksheet";
//            
//        case UI_PROBLEMBROWSER_AUTO_MATCH_OFF:
//            return "Auto Match OFF";
//        case UI_PROBLEMBROWSER_AUTO_MATCH_ON:
//            return "Auto Match ON";
//        case UI_PROBLEMBROWSER_TO_WORKSHEET:
//            return "To Worksheet";
//        case UI_PROBLEMBROWSER_START_REFINE:
//            return "Try Refine";
//        case UI_PROBLEMBROWSER_REFINE:
//        	return "Try Refine";
//        	
//        case UI_OPEN_WORKSHEET:
//        	return "NEW";
//            
//        case UI_SHOW_EXAMPLE_BROWSER:
//        	return "Examples";
//        	
//        case UI_SHOW_PROBLEM_BROWSER:
//        	return "Problems";        	
//            
//        case UI_SHOW_METHOD_BROWSER:
//        	return "Methods";        	
//
//        case UI_SHOW_THEORY_BROWSER:
//        	return "Theories";        	
//        	
//            /** 
//             * NC060616: This should be fixed
//             * NC060616: This is fixed and should never happen :)
//             */
//        case UI_SOLVE_SET_NEXT_TACTIC:
//        	return "Hmmm.... Interesting !";
//        }
//        return "";
    }

}