package isac.useractions;

import isac.users.UserLanguage;

import java.net.MalformedURLException;
import java.net.URL;

/**
 * 
 * UIActionOnLink is sent from the BrowserDialog->MiniBrowser
 * and tells the MiniBrowser that he should load the page given
 * with the link.
 * 
 */
public class UIActionOnLink extends UIAction {

	static final long serialVersionUID = -7422415204155295019L;
	
	private URL link_;
	
	public UIActionOnLink(EUIElement action, EUIContext context, UserLanguage ul, String link) {
		super(action, context, ul);
		
		try {
			link_ = new URL( link );
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
	}
	
	public UIActionOnLink(EUIElement action, EUIContext context, UserLanguage ul, URL link) {
		super(action, context, ul);
		
		link_ = link;
	}

	public URL getLink() {
		return link_;
	}

	public void setLink(URL link) {
		this.link_ = link;
	}

}
