/*
 * Created on Dec 12, 2003
 */
package isac.useractions;



/**
 * Describes an user action passing an integer value.
 * @see isac.useractions.UserActionOnIterator
 * @see isac.useractions.UserActionOnKEStoreID
 * @author Alan Krempler
 */
public class UserActionOnInt extends UserAction {
	
	static final long serialVersionUID = -9184631026857180736L;
	
	private int i_;
	
	/**
	 * @param id 
	 * @param i The integer value holding additional information to the UserAction
	 */
	public UserActionOnInt(EUIElement id, int i) {
		super(id);
		i_ = i; 
	}
	
	/**
	 * @return The integer value holding additional information to the UserAction
	 */
	public int getInt() {
		return i_;
	}

}
