/*
 * Created on Dec 12, 2003
 */
package isac.useractions;

import isac.interfaces.ICalcIterator;

/**
 * Describes an user action which relates to a CalcElement which
 * is part of the current calculation.
 * @see isac.useractions.UserActionOnCalcElement
 * @see isac.useractions.UserActionOnKEStoreID
 * @author Alan Krempler
 */
public class UserActionOnIterator extends UserAction {
	
	static final long serialVersionUID = 1796372389809990993L;
	
	private ICalcIterator iterator_;
	
	public UserActionOnIterator(EUIElement id, ICalcIterator iterator) {
		super(id);
		iterator_ = iterator; 
	}
	
	/* 
	 *  NC 060225 Why is this called getPosition() and not getIterator() ??
	 * @see isac.useractions.UserAction#getPosition()
	 */
	public ICalcIterator getIterator() {
		return iterator_;
	}

}
