/*
 * Created on Dec 12, 2003
 */
package isac.useractions;

import isac.util.formulae.HierarchyKey;

/**
 * Describes an user action on part of a CalcHead.
 * 
 * @see isac.useractions.UserActionOnIterator
 * @see isac.useractions.UserActionOnKEStoreID
 * @author Alan Krempler
 */
public class UserActionOnKEStoreID extends UserAction {
	
	static final long serialVersionUID = 7162941487575023750L;
	 
	private HierarchyKey chc_id_;
    private HierarchyKey kestore_id_;
    /**
     * @version 1.0
     * @param id
     *            IUIElement identifying the action
     * @param chc_id
     *            the data accompanied with this action
     */
    public UserActionOnKEStoreID(EUIElement id, HierarchyKey chc_id) {
        super(id);
        chc_id_ = chc_id;
    }

    public HierarchyKey getObjectID() {
        return chc_id_;
    }
    
	/**
	 * returns the KEStore id
	 * @return KEStore ID
	 */
	public HierarchyKey getKEStoreID() {
	    kestore_id_ = chc_id_;
	    System.out.println("KESTORE_ID: " + kestore_id_);
		return kestore_id_;
	}

}