package isac.useractions;

import java.net.MalformedURLException;
import java.net.URL;

/**
 * 
 * UserActionOnLink is sent from the MiniBrowser->BrowserDialog
 * and tells the BrowserDialog that the user has clicked on a
 * link.
 * 
 */
public class UserActionOnLink extends UserAction {

	static final long serialVersionUID = -2883146237730518486L;
	
	private URL link_;
	
	public UserActionOnLink(EUIElement id, EUIContext context, URL link ) {
		super(id, context);
		link_ = link;
	}
	
	public UserActionOnLink(EUIElement id, EUIContext context, String link) {
		super(id, context);
		
		try {
			link_ = new URL( link );
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
	}	

	/**
	 * @return Returns the link_.
	 */
	public URL getLink() {
		return link_;
	}

	/**
	 * @param link_ The link_ to set.
	 */
	public void setLink(URL link) {
		link_ = link;
	}


}
