/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2005 by Walther Neuper 
 * created Mar 12, 2005 8:09:42 AM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.users;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Properties;

/**
 * @author Walther Neuper
 * 
 * contains passwords looking forward to handle security issues elsewhere
 * (outside isac)
 */
public class Accounts extends Properties {

    static final long serialVersionUID = 6145685806086624884L;

	public Accounts(String userpath) {
        String filename = userpath + "accounts.txt";
        try {
            FileInputStream propInFile = new FileInputStream(filename);
            this.load(propInFile);
            this.list(System.out);
        } catch (FileNotFoundException e) {
            System.err.println("Can?t find " + filename);
        } catch (IOException e) {
            System.err.println("I/O failed.");
        }
    }

    public boolean exists(String username) {
        Enumeration keys = this.propertyNames();//WN050311 how better ?
        String key = null;
        while (keys.hasMoreElements()) {
            key = (String) keys.nextElement();
            if (key.compareTo(username) == 0)
                return true;
        }
        return false;
    }

    //WN050311 just for creation of the first file
    //beware of the fix path !
    public static void main(String[] args) {
        Accounts acs = new Accounts("isac/xmldata/users");
        acs.setProperty("x", "x");
        acs.setProperty("y", "y");
        acs.setProperty("anonymous", "anonymous");

        String filename = "isac/xmldata/users/accounts.txt";
        try {
            FileOutputStream propOutFile = new FileOutputStream(filename);
            acs.store(propOutFile, "the list of isac users");

        } catch (IOException e) {
            System.err.println("I/O failed.");
        }
    }

}