/****************************************************************** 
 * @author Alois Kirchsteiger member of the isac team
 * Copyright (c) 2004 by Alois Kirchsteiger
 * create 02.09.2004, 09:22:43
 * Insitute for Softwaretechnology, Graz University of Technology, Austria. 
 * 
 * Use is subject to license terms.
 ******************************************************************/

package isac.users;

import isac.users.UserLanguage.LanguageName;

import java.io.Serializable;

/**
 * @author Alois Kirchsteiger 02.09.2004 09:22:43
 */
public class User implements Serializable {

    static final long serialVersionUID = 1124381392757950882L;

	private String username_;

    private String userpath_;

    public User(String username, String userpath) {
        username_ = username;
        userpath_ = userpath;       
    }

    public UserAdmin getUserAdmin() {
        return new UserAdmin(userpath_, username_);

    }

    public UserModel getUserModel() {
        return new UserModel(userpath_, username_);
    }

    public UserSettings getUserSettings() {
        return new UserSettings(userpath_, username_);
    }

    public String getUsername() {
        return username_;
    }

    public String getUserpath() {
        return userpath_;
    }
    
    public UserLanguage getLanguage( ) {
    	UserSettings us = getUserSettings();
    	LanguageName name = LanguageName.ENGLISH;
    	switch( us.getValue( "KEY4_LANGUAGE" ) ) {
    	case IUserSettings.VAL4_ENGLISH:
    		name = LanguageName.ENGLISH;
    		break;
    	case IUserSettings.VAL4_DEUTSCH:
    		name = LanguageName.DEUTSCH;
    		break;
    	}
    	return new UserLanguage( userpath_, name ); 
    }

}