package isac.users;

import isac.useractions.EUIElement;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

public class UserLanguage {

	public enum LanguageName {
		ENGLISH,
		DEUTSCH
	}
	
    Properties action_labels_; 
    
	public UserLanguage( String path, LanguageName language ) {
		action_labels_ = new Properties();
        String filename = path + language.toString().toLowerCase() + "_labels.txt";
        try {
            FileInputStream propInFile = new FileInputStream(filename);
            action_labels_.load(propInFile);
            action_labels_.list(System.out);
        } catch (FileNotFoundException e) {
            System.err.println("Can not find " + filename);
        } catch (IOException e) {
            System.err.println("I/O failed.");
        }
	}

	public String getLabel( EUIElement action ) {
		return action_labels_.getProperty( action.toString() );
	}
}
