/*
 * @author Walther Neuper
 * Created on Apr 29, 2005
 *  
 */
package isac.util;

import isac.util.tactics.Tactic;

/**
 * @author Walther Neuper
 * 
 * <code>ICalcTree#startSolving</code> is done by
 * <code>ICalcTree#autoCalculate</code> which definitely uses
 * <code>Tactic</code> "Appl_Method" IF THE CALCHEAD IS COMPLETE, and any
 * other Tactic causes this Exception
 * 
 * analoguous with <code>Tactic</code> "Model_Problem"
 */
public class AutoCalculateException extends Exception {

    static final long serialVersionUID = -2123525290536414735L;

	public AutoCalculateException(Tactic tac) {
        super(tac.toSMLString());
    }
}