package isac.util;

 import java.io.IOException;
 import java.net.Socket;
 import java.net.ServerSocket;
import java.rmi.server.RMISocketFactory;

 /**
 * @author  Ralf Kellermann
 * @date 2003-08-26
 * @time 18:17
 */
 
 public class ObjectManagerRMISocketFactory extends RMISocketFactory
 {
	 	private int port_;
	 	private int server_port_;
	 	
	 	public ObjectManagerRMISocketFactory(int server_port, int port_to_use)
	 	{
	 		super();
	 		port_ = port_to_use;
	 		server_port_ = server_port;
	 	}
	 	
         /**
         * Creates a client socket connected to the specified host and port
         * @param host  the host name
         * @param port  the port number
         * @return a socket connected to the specified host and port.
         * @exception IOException if an I/O error occurs during socket creation
         */
         public Socket createSocket(String host, int port)
                 throws IOException
         {
        	 if ( port != -1 && port != 3113 )
        	 {
                 System.out.println("creating normal socket to rmiregistry host : " 
                         + host + " on port " + port);
                 return new Socket(host, port);

        	 }

        	 System.out.println("creating reverse CLIENT socket to host " + host + port );
             ServerSocket server_socket =  new ServerSocket(server_port_);
             Socket sock = server_socket.accept();
             server_socket.close();
             System.out.println("CLIENT socket to host " );
             return sock;

         }
 
         /**
         * Create a server socket on the specified port (port 0 indicates
         * an anonymous port) and writes out some debugging info
         * @param port  the port number
         * @return  the server socket on the specified port
         * @exception IOException  if an I/O error occurs during server socket
         * creation
         */
         public ServerSocket createServerSocket(int port)
                 throws IOException
         {
                 port = port_;
                 System.out.println("creating ServerSocket on port " + port);
                 return new ServerSocket(port);
         }
}

