/**
 * @author Richard Gradischnegg
 * Created on Nov 6, 2003
 *  
 */

package isac.util;

import isac.util.formulae.CalcHeadSimpleID;

/**
 * @author Richard Gradischnegg
 * 
 * This class is used to wrap the objects produced by the XMLDigestParser from
 * the XML-output of the kernel
 */
public class ResponseWrapper {

    /**
     * WN041105 _all_ possible objects on _first_ level of xml-objects in each
     * object FIXME WN0608 remove due to needlessnes: allocation to calculations
     * is done _before_ parsing (in Kernel2ClientsServer.run by start_seq_ =
     * "@@@@@begin@@@@@")
     */
    private CalcHeadSimpleID calc_id_;

    /**
     * in some objects, causes problems with CALCCHANGED, where Positions are
     * _not_ on first level: these require different tags UNCHANGED etc.
     * 
     * @see isac.util.parser.XMLParserDigest addObjectCreate("/POSITION"
     */
    // contains the data
    private Object response_;

    public Object getResponse() {
        return response_;
    }

    public void setResponse(Object o) {
        response_ = o;
    }

    public int getCalcID() {
        if (calc_id_ != null) {
            return Integer.parseInt(calc_id_.getID());
        } else {
            return 0;
        }
    }

    public void setCalcID(CalcHeadSimpleID idObject) {
        this.calc_id_ = idObject;
    }

}