/*
 * @author Walther Neuper, member of the ISAC-team, Copyright (c) 2004 by
 * Walther Neuper created Sep 20, 2004, 4:18:31 PM Institute for
 * Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.util.formulae;

import java.util.Vector;

import isac.interfaces.ICalcElement;

/**
 * The assumptions generated by application of the tactic to the formula, both
 * under the same CalcIterator.
 * 
 * *ATTENTION*: still also used for
 * {isac.interfaces.ICalcIterator#fetchApplicalbeTactics} as long as this does
 * _not_ return references to _several_ Formula holding Assumptions
 * 
 * @author Walther Neuper Sep 20, 2004, 4:18:31 PM
 * @version 1.0
 */
public class Assumptions implements ICalcElement {

    static final long serialVersionUID = -8370814571485358510L;
	Vector formulae_;

    public Assumptions() {
        super();
        formulae_ = new Vector();
    }

    /**
     * @see isac.interfaces.ICalcElement#toSMLString()
     */
    public String toSMLString() {
        String s = "";
        if (!formulae_.isEmpty()) {
            for (int i = 0; i < formulae_.size() - 1; i++)
                s = ((Formula) formulae_.elementAt(i)).toSMLString() + " /\\ ";
            s = s + ((Formula) formulae_.lastElement()).toSMLString();
        }
        return s;
    }

    /*
     * (non-Javadoc)
     * 
     * @see isac.interfaces.ICalcElement#getMathML()
     */
    public String getMathML() {
        return null;
    }

    /*
     * (non-Javadoc)
     * 
     * @see isac.interfaces.ICalcElement#getType()
     */
    public int getType() {
        return 0;
    }

    /*
     * (non-Javadoc)
     * 
     * @see isac.interfaces.ICalcElement#getVisibility()
     */
    public int getVisibility() {
        return 0;
    }

    /*
     * (non-Javadoc)
     * 
     * @see isac.interfaces.ICalcElement#setVisibility(int)
     */
    public void setVisibility(int visibility) {

    }

    /*
     * (non-Javadoc)
     * 
     * @see isac.interfaces.ICalcElement#getViewStyle()
     */
    public int getViewStyle() {
        return 0;
    }

    /*
     * (non-Javadoc)
     * 
     * @see isac.interfaces.ICalcElement#setViewStyle(int)
     */
    public void setViewStyle(int view_style) {

    }

    /*
     * (non-Javadoc)
     * 
     * @see isac.interfaces.ICalcElement#getRating()
     */
    public int getRating() {
        return 0;
    }

    /*
     * (non-Javadoc)
     * 
     * @see isac.interfaces.ICalcElement#setRating(int)
     */
    public void setRating(int rating) {

    }

    //also used in XMLParser @see {isac.util.parser.XMLParserDigest}
    public void setFormula(Formula asm) {
        formulae_.add(asm);
    }

    public Vector getFormulae() {
        return formulae_;
    }

}