/*
 * @author Robert Koenighofer, member of the ISAC-team, 
 * Copyright (c) 2006 by Robert Koenighofer
 * created Jul 11, 2006 10:09:13 AM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */

package isac.util.formulae;

/**
 * FIXXME: what does this class contain in detail?
 * 
 * @author Robert Koenighofer
 */
public class ContextMethod extends Context {

	/**
	 * For serialization, see corresponding API Documentation; value generated
	 * by eclipse to avoid a warning
	 */
	private static final long serialVersionUID = -5695071865664301250L;

	private String status_;

	private Formula script_;

	private Model model_;

	public String getStatus() {
		return status_;
	}

	public Formula getScript() {
		return script_;
	}

	public Model getModel() {
		return model_;
	}

	public void setStatus(String status) {
		this.status_ = status;
	}

	public void setScript(Formula script) {
		this.script_ = script;
	}

	public void setModel(Model model) {
		this.model_ = model;
	}

	/**
	 * Transforms the content of the object into a string representation.
	 *  @return the string representation of the Context
	 */
	/*
	 public String toString() {
	 // TODO RK060710 implement me
	 //System.out.println("TODO: isac.util.formulae.ContextMethod#toString(): implement me!");
	 //System.exit(-1);
	 return null;
	 }*/

	/**
	 * Transforms the content of the object into a HTML representation.
	 *  @return the HTML representation of the Context
	 */
	public String toHTML() {
		String start_color_green = "<font color=\"#00cc33\">";
		String start_color_red = "<font color=\"#ff0000\">";
		String end_color = "</font>";
		String result = "";
		
		System.out.println(script_.toString());
		System.out.println(script_.toSMLString());
		
		result += "<div class=\"context\">\n";

		result += "<h5>Guard: </h5>\n";
		if (model_ != null) {
			result += "   <table style=\"text-align: left; width: 100%;\" border=\"1\" cellspacing=\"0\"\n";
			result += "    cellpadding=\"2\">\n";
			result += "     <tbody>\n";

			if (model_.getGiven() != null) {
				result += "   <tr>\n";
				result += "   <td width=\"60\">\n";
				boolean all_correct = true;
				for (int count = 0; count < model_.getGiven()
						.getNumberOfItems(); count++) {
					ModelItem item = (ModelItem) model_.getGiven().getItems()
							.get(count);
					if (item.getStatus() != ModelItem.STATUS_CORRECT)
						all_correct = false;
				}
				result +="<h5>\n";
				if (all_correct)
					result += start_color_green;
				else
					result += start_color_red;
				result += "Given:\n";
				result += end_color;
				result +="</h5>\n";
				result += "   </td>\n";
				result += "   <td> \n";

				for (int count = 0; count < model_.getGiven()
						.getNumberOfItems(); count++) {
					ModelItem item = (ModelItem) model_.getGiven().getItems()
							.get(count);
					if (item.getStatus() == ModelItem.STATUS_CORRECT)
						result += start_color_green;
					else
						result += start_color_red;
					result += item.toSMLString() + "<br>\n";
					result += end_color;
				}
				if (model_.getGiven().getNumberOfItems() == 0)
					result += "&nbsp;\n";

				result += "   </td>\n";
				result += "   </tr>\n";
			}
			if (model_.getWhere() != null) {
				result += "   <tr>\n";
				result += "   <td>\n";
				boolean all_correct = true;
				for (int count = 0; count < model_.getWhere()
						.getNumberOfItems(); count++) {
					ModelItem item = (ModelItem) model_.getWhere().getItems()
							.get(count);
					if (item.getStatus() != ModelItem.STATUS_CORRECT)
						all_correct = false;
				}
				result +="<h5>\n";
				if (all_correct)
					result += start_color_green;
				else
					result += start_color_red;
				result += "Where:\n";
				result += end_color;
				result +="</h5>\n";
				result += "   </td>\n";
				result += "   <td>\n";
				for (int count = 0; count < model_.getWhere()
						.getNumberOfItems(); count++) {
					ModelItem item = (ModelItem) model_.getWhere().getItems()
							.get(count);
					if (item.getStatus() == ModelItem.STATUS_CORRECT)
						result += start_color_green;
					else
						result += start_color_red;
					result += item.toSMLString() + "<br>\n";
					result += end_color;
				}
				if (model_.getWhere().getNumberOfItems() == 0)
					result += "&nbsp;\n";

				result += "   </td>\n";
				result += "   </tr>\n";
			}
			if (model_.getFind() != null) {
				result += "\n";
				result += "   <tr>\n";
				result += "   <td>\n";
				boolean all_correct = true;
				for (int count = 0; count < model_.getFind().getNumberOfItems(); count++) {
					ModelItem item = (ModelItem) model_.getFind().getItems()
							.get(count);
					if (item.getStatus() != ModelItem.STATUS_CORRECT)
						all_correct = false;
				}
				result +="<h5>\n";
				if (all_correct)
					result += start_color_green;
				else
					result += start_color_red;
				result += "Find:\n";
				result += end_color;
				result +="</h5>\n";
				result += "   </td>\n";
				result += "   <td>\n";
				for (int count = 0; count < model_.getFind().getNumberOfItems(); count++) {
					ModelItem item = (ModelItem) model_.getFind().getItems()
							.get(count);
					if (item.getStatus() == ModelItem.STATUS_CORRECT)
						result += start_color_green;
					else
						result += start_color_red;
					result += item.toSMLString() + "<br>\n";
					result += end_color;
				}
				if (model_.getFind().getNumberOfItems() == 0)
					result += "&nbsp;\n";
				result += "   </td>\n";
				result += "   </tr>\n";
				result += "\n";
			}
			if (model_.getRelate() != null) {
				result += "   <tr>\n";
				result += "   <td>\n";
				boolean all_correct = true;
				for (int count = 0; count < model_.getRelate()
						.getNumberOfItems(); count++) {
					ModelItem item = (ModelItem) model_.getRelate().getItems()
							.get(count);
					if (item.getStatus() != ModelItem.STATUS_CORRECT)
						all_correct = false;
				}
				result +="<h5>\n";
				if (all_correct)
					result += start_color_green;
				else
					result += start_color_red;
				result += "Relate:\n";
				result += end_color;
				result +="</h5>\n";
				result += "   </td>\n";
				result += "   <td>\n";
				for (int count = 0; count < model_.getRelate()
						.getNumberOfItems(); count++) {
					ModelItem item = (ModelItem) model_.getRelate().getItems()
							.get(count);
					if (item.getStatus() == ModelItem.STATUS_CORRECT)
						result += start_color_green;
					else
						result += start_color_red;
					result += item.toSMLString() + "<br>\n";
					result += end_color;
				}
				if (model_.getRelate().getNumberOfItems() == 0)
					result += "&nbsp;\n";
				result += "   </td>\n";
				result += "   </tr>\n";
			}
			result += "   </tbody>\n";
			result += "   </table>\n";
		}
		result += "</div>\n";
		//System.out.println(result);
		return result;
	}
}
