/*
 * @author Robert Koenighofer, member of the ISAC-team, 
 * Copyright (c) 2006 by Robert Koenighofer
 * created Jul 11, 2006 10:09:13 AM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.util.formulae;

import java.io.Serializable;

/**
 * This class represents the key for the KEStore FIXXME: anything more
 * necessary? maybe a List instead of a String?
 * 
 * @author Robert Koenighofer
 */
public class KEStoreKey implements Serializable {

	static final long serialVersionUID = -3304223790422951718L;

	String key_;

	public void setKey(String key) {
		this.key_ = key;
	}

	/**
	 * Constructor constructs the KEStoreKey out of a string representation.
	 * 
	 */
	public KEStoreKey(String key) {
		key_ = key;
	}

	/**
	 * Constructor for parsing a KEStoreKey - Calling the constructor with
	 * arguments made problems
	 */
	public KEStoreKey() {
	}

	/**
	 * Transforms the key into a string representation.
	 * 
	 * @return the string representation of the Context
	 */
	public String toString() {
		return key_;
	}

	public boolean equals(Object o) {
		return (key_.compareTo(o.toString()) == 0);
	}
}
