/*
 * @author Walther Neuper, member of the ISAC-team, Copyright (c) 2004 by
 * Walther Neuper created Sep 30, 2004, 3:35:30 PM Institute for
 * Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.util.formulae;

import java.util.Iterator;
import java.util.Vector;

/**
 * identifier for a method and key into the hierarchy_ of methods
 * 
 * @author Walther Neuper Sep 30, 2004, 3:35:30 PM
 * @version 1.0
 * @see <isac.util.formulae.ProblemID>
 */
public class MethodID extends HierarchyKey {

//    private Vector method_id_ = new Vector();

    public MethodID() {
    }

    /** 
     * Description of the class
     * @author Walther Neuper
     * @version 1.0
     * @see <fully.qualified.Classname#methodName(param-classes)>
     * @deprecated <if applicable write reason here, otherwise omit>
     */ 
    
    public MethodID(Vector keylist) {
        super.setID(keylist);
    }

    public String toSMLString() {
        StringBuffer sb = new StringBuffer();
        if (super.getID().size() > 0) {
            sb.append(" [");
            Iterator it = super.getID().iterator();
            while (it.hasNext()) {
                sb.append("\"" + it.next() + "\",");
            }
            sb.deleteCharAt(sb.length() - 1); // remove last ","
            sb.append("]");
        } else {
            sb.append("[]");
        }
        return sb.toString();
    }

}