/*
 * @author Andreas Griesmayer, Martin Lang
 * Created on Jun 24, 2003
 *  
 */
package isac.util.genhtml;

import isac.util.KEStoreCommunication;
import isac.util.KEStorePaths;
import isac.util.parser.XMLParserDigest;

import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.StringReader;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Source;
import javax.xml.transform.stream.StreamSource;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

/**
 * @author Andreas Griesmayer
 *  
 */
public class GenHTML {

    static final int PBLTREE_XSL = 1;

    static final int METTREE_XSL = 2;

    static final int EXPTREE_XSL = 3;

    static final int SIMPLE_HIERARCHY_XSL = 4;

    static final int SIMPLE_PBL_NODE = 5;

    //storage-destination for the generated html-files
    //fixed path /windows/E/xmldata_last/
   // static String destination_ = "/home/mLa/isac_html_files/";
    static String destination_ = KEStorePaths.GENHTML_DESTINATON_PATH;
    private static FileWriter error_log;

    public static void main(String[] args) {
        
		if (args.length != 1) {
			System.out
					.println("Only the path to the config file is allowed as one and only parameter");
			System.exit(1);
		}
		KEStorePaths.setConstants(args[0]);
        
    	//storage-destination of the problems occuring in the xml files
        try {
            error_log = new FileWriter(
            //fixed path /windows/E/xmldata_last/GENHTML_error_log.txt
                    KEStorePaths.GENHTML_DESTINATON_PATH+"GENHTML_error_log.txt");
        } catch (IOException e) {
            e.printStackTrace();
        }

        if (args.length > 0)
            destination_ = KEStorePaths.GENHTML_DESTINATON_PATH;
        GenHTML genhtml = new GenHTML();
        //fixed path met/code.html ???
        
        genhtml.buildHierarchy("met/code.html");
        genhtml.buildHierarchy("met/index.html");
        genhtml.buildHierarchy("met/heading.html");
        genhtml.buildHierarchy("met/menu_empty.html");
        genhtml.buildHierarchy("met/main.html");

        //fixed path pbl/code.html ???
        genhtml.buildHierarchy("pbl/code.html");
        genhtml.buildHierarchy("pbl/index.html");
        genhtml.buildHierarchy("pbl/heading.html");
        genhtml.buildHierarchy("pbl/menu_empty.html");
        genhtml.buildHierarchy("pbl/main.html");
        
        //fixed path thy/code.html ???
        
        genhtml.buildHierarchy("thy/code.html");
        genhtml.buildHierarchy("thy/index.html");
        genhtml.buildHierarchy("thy/heading.html");
        genhtml.buildHierarchy("thy/menu_empty.html");
        genhtml.buildHierarchy("thy/main.html");

        //fixed path exp/code.html ???
        genhtml.buildHierarchy("exp/code.html");
        genhtml.buildHierarchy("exp/index.html");
        genhtml.buildHierarchy("exp/heading.html");
        genhtml.buildHierarchy("exp/menu_empty.html");
        genhtml.buildHierarchy("exp/main.html");

        //fixed path ???
        
        Set exp_set = genhtml.loadFileList("exp");
        Iterator exp_it = exp_set.iterator();
        int index = exp_set.size();
        while (exp_it.hasNext()) {
            System.out.println("exp to generate:" + (index--));
            genhtml.loadContent("exp/" + exp_it.next());
        }

        //fixed path ???
        Set pbl_set = genhtml.loadFileList("pbl");
        index = pbl_set.size();
        Iterator pbl_it = pbl_set.iterator();
        while (pbl_it.hasNext()) {
            System.out.println("pbl to generate:" + (index--));
            genhtml.loadContent("pbl/" + pbl_it.next());
        }
        
        //fixed path ???
        Set thy_set = genhtml.loadFileList("thy");
        index = thy_set.size();
        Iterator thy_it = thy_set.iterator();
        while (thy_it.hasNext()) {
            System.out.println("thy to generate:" + (index--));
            genhtml.loadContent("thy/" + thy_it.next());
        }

        //fixed path ???
        Set met_set = genhtml.loadFileList("met");
        index = met_set.size();
        Iterator met_it = met_set.iterator();
        while (met_it.hasNext()) {
            System.out.println("met to generate:" + (index--));
            genhtml.loadContent("met/" + met_it.next());
        }

        try {
            error_log.close();
        } catch (IOException e1) {
            e1.printStackTrace();
        }
    }

    Set loadFileList(String type) {
        Set return_set = new HashSet();
        try {

            DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
            DocumentBuilder db = dbf.newDocumentBuilder();

            InputSource inputsource = new InputSource(new StringReader(
                    //fixed path ???
                    KEStoreCommunication.loadHierarchy("", type)));
            Document document = db.parse(inputsource);

            Element doc_elem = document.getDocumentElement();
            NodeList nodelist = doc_elem.getElementsByTagName("CONTENTREF");
            for (int index = 0; index < nodelist.getLength(); index++) {
                return_set.add(nodelist.item(index).getFirstChild()
                        .getNodeValue().trim());
            }

            nodelist = doc_elem.getElementsByTagName("EXAMPLE");
            for (int index = 0; index < nodelist.getLength(); index++) {
                return_set.add(nodelist.item(index).getFirstChild()
                        .getNodeValue().trim());
            }
        } catch (ParserConfigurationException e) {
            e.printStackTrace();
        } catch (SAXException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return return_set;
    }

    /**
     * Loads all hierarchies which are displayed on the web-browser
     */
    protected void buildHierarchy(String path) {

        String session = ""; ///FIXXXME why is here an empty
        // session ID??? -> Problem with
        // BrwoserDialog
        StringTokenizer tokens = new StringTokenizer(path, "/");
        //	(String)request.getSession().getAttribute("session_id");
        //	if(session==null)
        //	    session="";
        path = "";
        String type = tokens.nextToken();

        if (!tokens.hasMoreTokens())
            path = "/index.html";
        else
            while (tokens.hasMoreTokens())
                path += "/" + tokens.nextToken();
        try {
            if (path.endsWith("code.html")) {
                Vector parameter = new Vector();
                parameter.add(session);
                parameter.add(type);
                Vector result;
                Source xslSource = null;
                String hierarchy_string = KEStoreCommunication.loadHierarchy(session, type);
                hierarchy_string = hierarchy_string.replaceAll(".xml </CONTENTREF>"," </CONTENTREF>");
                Source xmlSource = new StreamSource(new StringReader(hierarchy_string));

                if (type.equals("pbl"))
                    xslSource = new StreamSource(
                            //fixed path /isac/util/genhtml/templates/pbl_hierarchy_jmenu.xsl
                            getClass()
                                    .getResourceAsStream(
                                            "/isac/util/genhtml/templates/pbl_hierarchy_jmenu.xsl"));
                else if (type.equals("met"))
                    xslSource = new StreamSource(
                            //fixed path /isac/util/genhtml/templates/met_hierarchy_jmenu.xsl
                            getClass()
                                    .getResourceAsStream(
                                            "/isac/util/genhtml/templates/met_hierarchy_jmenu.xsl"));
                
                else if (type.equals("thy"))
                    xslSource = new StreamSource(
                            //fixed path /isac/util/genhtml/templates/thy_hierarchy_jmenu.xsl
                            getClass()
                                    .getResourceAsStream(
                                            "/isac/util/genhtml/templates/thy_hierarchy_jmenu.xsl"));
                
                else
                    xslSource = new StreamSource(
                            //fixed path /isac/util/genhtml/templates/exp_hierarchy_jmenu.xsl
                            getClass()
                                    .getResourceAsStream(
                                            "/isac/util/genhtml/templates/exp_hierarchy_jmenu.xsl"));
                //fixed path /isac/util/genhtml/templates/codeheader.html
                String header = toString(getClass().getResourceAsStream(
                        "/isac/util/genhtml/templates/codeheader.html"));
                //fixed path /isac/util/genhtml/templates/codefooter.html
                String footer = toString(getClass().getResourceAsStream(
                        "/isac/util/genhtml/templates/codefooter.html"));

                // Perform the transformation, sending the output to the
                // response.
                //java.io.PrintWriter out = response.getWriter();
                FileWriter out = new FileWriter(destination_ + type + "/"
                        + path);
                out.write(header);
                Encoder.encodeInformation(xslSource, xmlSource, out);
                out.write(footer);
                out.close();
            } else {
                if (path.trim().endsWith("index.html")) {
                    if (type.equals("pbl")) {
                        path = "index_pbl.html";
                    } else if (type.equals("met"))
                        path = "index_met.html";
                    else if (type.equals("thy"))
                        path = "index_thy.html";
                    else
                        path = "index_exp.html";
                }
                System.out.println(path);
                //fixed path /isac/util/genhtml/jscript/
                InputStream istream = getClass().getResourceAsStream(
                        "/isac/util/genhtml/jscript/" + path);
                FileWriter out = new FileWriter(destination_ + type + "/"
                        + path);
                int input;
                while ((input = istream.read()) != -1) {
                    out.write(input);
                }
                out.close();
            }

        } catch (IOException exc) {
            System.out.println("IOException:" + exc.getMessage());
        }
    }

    public String toString(InputStream istream) {
        StringBuffer buf = new StringBuffer(10000);
        int input;
        try {
            while ((input = istream.read()) != -1) {
                buf.append((char) input);
            }
        } catch (IOException e) {
            return getErrorXML("Sorry, IOException while accessing the InputStream "
                    + e.getMessage());
        }
        return buf.toString();
    }

    private static String getErrorXML(String string) {
        return "<ERROR><DESCRIPTION> <h1> Error in file LoadHierarchy.java </h1>"
                + string + "</DESCRIPTION></ERROR>";
    }

    protected void loadFile(String path) {
        StringTokenizer tokens = new StringTokenizer(path, "/");
        //		(String)request.getSession().getAttribute("session_id");
        //		if(session==null)
        //			session="";
        String session_id = "";
        path = "";
        String type = (String) tokens.nextToken();

        if (!tokens.hasMoreTokens())
            path = "/index.html";
        else
            while (tokens.hasMoreTokens())
                path += "/" + tokens.nextToken();
        try {
            if (path.endsWith("code.html")) {
                Vector parameter = new Vector();
                parameter.add(session_id);
                parameter.add(type);
                Vector result;
                Source xmlSource = new StreamSource(new StringReader(
                        KEStoreCommunication.loadHierarchy(session_id, type)));

                // Perform the transformation, sending the output to the
                // response.
                java.io.FileWriter out = new FileWriter(destination_ + type
                        + "/" + path);
                Encoder.encodeHierarchy(type, xmlSource, out);
                return;
            } else if (path.trim().endsWith("heading.html")) {
                java.io.FileWriter out = new FileWriter(destination_ + type
                        + "/" + path);
                out.write(getHeader(session_id));
                return;
            } else if (path.trim().endsWith("treecontent.html")) {
                Vector parameter = new Vector();
                parameter.add(session_id);
                parameter.add(type);
                Vector result;
                Source xmlSource = new StreamSource(new StringReader(
                        KEStoreCommunication.loadHierarchy(session_id, type)));

                // Perform the transformation, sending the output to the
                // response.
                java.io.FileWriter out = new FileWriter(destination_ + type
                        + "/" + path);

                Encoder.encodeHContent(type, xmlSource, out);
                return;
            }
            //TODO this type should not result in different files but in an
            // autogeneration of a fitting file
            if (path.trim().endsWith("index.html")) {
                if (type.equals("pbl")) {
                    path = "index_pbl.html";
                } else if (type.equals("met"))
                    path = "index_met.html";
                else if (type.equals("thy"))
                    path = "index_thy.html";
                else
                    path = "index_exp.html";
            }
            InputStream istream = getClass().getResourceAsStream(
                    //fixed path /isac/BrowserServlet/jscript/ OUT OF DATE
                    "/isac/BrowserServlet/jscript/" + path);
            java.io.FileWriter out = new FileWriter(destination_ + type + "/"
                    + path);
            int input;
            while ((input = istream.read()) != -1) {
                out.write(input);
            }

        } catch (IOException exc) {
            System.out.println("bla");
        }
    }

    private String getHeader(String session_id) {
        String headercontent = "<html>"
                + "<body>"
                + "<a href=\"../../isac.BrowserServlet.Login\" target=\"text\">"
                + " login </a>"
                + "&nbsp;&nbsp;"
                + "<a href=\"../../isac.BrowserServlet.Logout\" target=\"text\">"
                + " logout </a>"
                + "<br> <a href=\"../../isac.BrowserServlet.LoadFile/pbl/index.html\" target=\"_top\">PBLHierarchy</a>"
                + "&nbsp;&nbsp;<a href=\"../../isac.BrowserServlet.LoadFile/met/index.html\" target=\"_top\">METHierarchy</a>"
                + "&nbsp;&nbsp;<a href=\"../../isac.BrowserServlet.LoadFile/thy/index.html\" target=\"_top\">THYHierarchy</a>"
                + "&nbsp;&nbsp;<a href=\"../../isac.BrowserServlet.LoadFile/exp/index.html\" target=\"_top\">ExampleHierarchy</a>"
                + "&nbsp;&nbsp;";

        String username = "";
        /*
         * if ((username = InformationProcessor.getUsername(session_id)) ==
         * null) headercontent += "not logged in"; else
         */
        headercontent += " welcome <b>" + username + "</b>";
        headercontent += "</body> </html>";
        return headercontent;
    }

    protected void loadContent(String path) {

    	if(!path.endsWith(".xml"))
    		path += ".xml";
    	//if(!path.startsWith("thy_isac_RootEq-rls"))
    	//	return;
        StringTokenizer tokens = new StringTokenizer(path, "/");
        String session = "";

        Vector parameter = new Vector();
        parameter.add(session);
        try {
            Source xslSource = null;
            Source xslSource_author = null;
            Source xslSource_nomodel = null;
            Source xmlSource = null;
            Source xmlSource_author = null;
            Source xmlSource_nomodel = null;

            String command = tokens.nextToken();
         
            String header = "<HTML xmlns=\"http://www.w3.org/1999/xhtml\"\n"
                    + "xmlns:math=\"http://www.w3.org/1998/Math/MathML\"\n"
                    + "xmlns:xlink=\"http://www.w3.org/1999/xlink\">\n";

            FileWriter out;
            FileWriter out_author;
            FileWriter out_nomodel;

            //removing the ".xml" from the PathString
            String file_name = path.substring(0, path.length() - 4);

            parameter.add(command);
            if (!tokens.hasMoreElements()) {
                out = new FileWriter(destination_ + file_name + ".html");
                out.write(header);
                out.write("no details");
                return;
            }
            String contentfile = tokens.nextToken();
            parameter.add(contentfile);

            if (!contentfile.trim().endsWith(".xml")) {
                return;
            }

            out = new FileWriter(destination_ + file_name + ".html");
            out_author = new FileWriter(destination_ + file_name
                    + "_author.html");
            out_nomodel = new FileWriter(destination_ + file_name
                    + "_nomodel.html");
            
            //loading the content from the xml
            String result = KEStoreCommunication.loadContent(session, command,
                    contentfile);
              
            if (result.startsWith("ERROR")) {
                result = result.substring(5, result.length());
                try {
                    error_log.write(result + '\n');
                    error_log.flush();
                    return;

                } catch (IOException e1) {
                    e1.printStackTrace();
                }
            }
                        
            xmlSource = new StreamSource(new StringReader(result));            
            xmlSource_author = new StreamSource(new StringReader(result));
            xmlSource_nomodel = new StreamSource(new StringReader(result));

            //deciding which stylesheet to use
            if (contentfile.trim().startsWith("pbl")) {
                xslSource = new StreamSource(getClass().getResourceAsStream(
                        //fixed path /isac/util/genhtml/templates/pbl_node_content.xsl
                        "/isac/util/genhtml/templates/pbl_node_content.xsl"));
                xslSource_author = new StreamSource(
                        getClass()
                                .getResourceAsStream(
                                        //fixed path /isac/util/genhtml/templates/pbl_node_content_author.xsl
                                        "/isac/util/genhtml/templates/pbl_node_content_author.xsl"));
                xslSource_nomodel = new StreamSource(
                        getClass()
                                .getResourceAsStream(
                                        //fixed path /isac/util/genhtml/templates/pbl_node_content_author.xsl
                                        "/isac/util/genhtml/templates/pbl_node_content_nomodel.xsl"));
                
                // generating the nomodel html from the pbl
                out_nomodel.write(header);
                Encoder.encodeInformation(xslSource_nomodel, xmlSource_nomodel, out_nomodel);
                out_nomodel.close();

            }

            else if (contentfile.trim().startsWith("met")) {
                xslSource = new StreamSource(getClass().getResourceAsStream(
                        //fixed path /isac/util/genhtml/templates/met_node_content.xsl
                        "/isac/util/genhtml/templates/met_node_content.xsl"));
                xslSource_author = new StreamSource(
                        getClass()
                                .getResourceAsStream(
                                        //fixed path /isac/util/genhtml/templates/met_node_content_author.xsl
                                        "/isac/util/genhtml/templates/met_node_content_author.xsl"));
                xslSource_nomodel = new StreamSource(
                        getClass()
                        .getResourceAsStream(
                                //fixed path /isac/util/genhtml/templates/pbl_node_content_author.xsl
                        "/isac/util/genhtml/templates/met_node_content_nomodel.xsl"));
                	
                // generating the nomodel html from the met
                out_nomodel.write(header);
                Encoder.encodeInformation(xslSource_nomodel, xmlSource_nomodel, out_nomodel);
                out_nomodel.close();
            }
            else if (contentfile.trim().startsWith("thy")) {
                xslSource = new StreamSource(getClass().getResourceAsStream(
                        //fixed path /isac/util/genhtml/templates/thy_node_content.xsl
                        "/isac/util/genhtml/templates/thy_node_content.xsl"));
                xslSource_author = new StreamSource(
                        getClass()
                                .getResourceAsStream(
                                        //fixed path /isac/util/genhtml/templates/thy_node_content_author.xsl
                                        "/isac/util/genhtml/templates/thy_node_content_author.xsl"));
                xslSource_nomodel = new StreamSource(
                        getClass()
                        .getResourceAsStream(
                                //fixed path /isac/util/genhtml/templates/thy_node_content_author.xsl
                        "/isac/util/genhtml/templates/thy_node_content_nomodel.xsl"));
                	
                // generating the nomodel html from the thy
                out_nomodel.write(header);
                Encoder.encodeInformation(xslSource_nomodel, xmlSource_nomodel, out_nomodel);
                out_nomodel.close();
            }

            else if (contentfile.trim().startsWith("exp")) {
                xslSource = new StreamSource(getClass().getResourceAsStream(
                        //fixed path /isac/util/genhtml/templates/exp_node_content.xsl
                        "/isac/util/genhtml/templates/exp_node_content.xsl"));
                xslSource_author = new StreamSource(
                        getClass()
                                .getResourceAsStream(
                                        //fixed path /isac/util/genhtml/templates/exp_node_content_author.xsl
                                       "/isac/util/genhtml/templates/exp_node_content_author.xsl"));
            }

            // Perform the transformation, sending the output to the response.
            out.write(header);
            out_author.write(header);
            Encoder.encodeInformation(xslSource, xmlSource, out);
            out.close();
            Encoder.encodeInformation(xslSource_author, xmlSource_author,
                    out_author);
            out_author.close();

        } catch (IOException exc) {
            exc.printStackTrace();
        }
        //	arg1.getWriter().print("pathinfo: "+arg0.getPathInfo()+"\n
        // transl:"+arg0.getPathTranslated());
    }

}