<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

<xsl:output method="html"/>


<!--
  Call the template below to insert the content of a tag with
  replacement of newlines by <br> as following: 
  <xsl:call-template name="insert_with_line_breaks">
    <xsl:with-param name="text" select="TAG_TO_SELECT"/>
  </xsl:call-template>
-->
<xsl:template name="insert_with_line_breaks">
  <xsl:param name="text" select="."/>
  <xsl:choose>
  <xsl:when test="contains($text, '&#xa;')">
  	<xsl:value-of select="substring-before($text,'&#xa;')"/>
  	<br/>
  	<xsl:call-template name="insert_with_line_breaks">
  		<xsl:with-param name="text" select="substring-after($text,'&#xa;')"/>
  	</xsl:call-template>
  </xsl:when>
  <xsl:otherwise>
  	<xsl:value-of select="$text"/>
  </xsl:otherwise>
  </xsl:choose>
</xsl:template>



<xsl:template match="EXAMPLE/NO">
</xsl:template>


<xsl:template match="EXAMPLE/DESCRIPTION">
    <xsl:copy-of select="."/>
    <p></p>
    <hr></hr>
    <h4>Formalization:</h4>
</xsl:template>

<xsl:template match="EXAMPLE/FORMALIZATION/VARIANT/TERMLIST/MATHML/ISA">
    <li>
    <xsl:value-of select="."/>    
    </li>
</xsl:template>

<xsl:template match="EXAMPLE/FORMALIZATION/VARIANT/SPECIFICATION/THEORY">
<br></br>
<xsl:for-each select=".">
<b>Theory:</b>
    <xsl:copy-of select="."/>    
    <br></br>  
    </xsl:for-each>
</xsl:template>

<xsl:template match="EXAMPLE/FORMALIZATION/VARIANT/SPECIFICATION/PROBLEM/KEY/ID">
<br></br>
<xsl:for-each select=".">
<b>Problem:</b>
    <xsl:value-of select="."/>    
   </xsl:for-each>
    <br></br>
</xsl:template>

<xsl:template match="EXAMPLE/FORMALIZATION/VARIANT/SPECIFICATION/METHOD/KEY/ID">
<br></br>
<xsl:for-each select=".">
<b>Method:</b>
    <xsl:value-of select="."/>    
    <br></br>
    </xsl:for-each>
     <br></br>     
</xsl:template>


<xsl:template match="EXAMPLE/AUTHOR">
<hr></hr>
(c)
<xsl:copy-of select="."/>
<br>
</br>
</xsl:template>


</xsl:stylesheet>