<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE xsl:stylesheet [<!ENTITY nbsp "&#x00A0;"> ]>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

<!--
  Call the template below to insert the content of a tag with
  replacement of newlines by <br> as following: 
  <xsl:call-template name="insert_with_line_breaks">
    <xsl:with-param name="text" select="TAG_TO_SELECT"/>
  </xsl:call-template>
-->
<xsl:template name="insert_with_line_breaks">
  <xsl:param name="text" select="."/>
  <xsl:choose>
  <xsl:when test="contains($text, '&#xa;')">
  	<xsl:value-of select="substring-before($text,'&#xa;')"/>
  	<br/>
  	<xsl:call-template name="insert_with_line_breaks">
  		<xsl:with-param name="text" select="substring-after($text,'&#xa;')"/>
  	</xsl:call-template>
  </xsl:when>
  <xsl:otherwise>
  	<xsl:value-of select="$text"/>
  </xsl:otherwise>
  </xsl:choose>
</xsl:template>


<xsl:template match="/">
<html>

<body>

<h4>Simplifiers: </h4>

<xsl:for-each select="NODECONTENT/EVALPRECOND">
<h5>for evaluating the preconditions: </h5>
<ul>
<li>
<xsl:value-of select="."/>
</li>
</ul>
</xsl:for-each>

<xsl:for-each select="NODECONTENT/EVALCOND">
<h5>for evaluating the conditions in rewrite rules: </h5>
<ul>
<li>
<xsl:value-of select="."/>
</li>
</ul>
</xsl:for-each>

<xsl:for-each select="NODECONTENT/EVALLISTEXPR">
<h5>for evaluating the list expressions: </h5>
<ul>
<li>
<xsl:value-of select="."/>
</li>
</ul>
</xsl:for-each>


<xsl:for-each select="NODECONTENT/CHECKELEMENTWISE">
<h5>for evaluating 'check_elementwise: </h5>
<ul>
<li>
<xsl:value-of select="."/>
</li>
</ul>
</xsl:for-each>

<xsl:for-each select="NODECONTENT/NORMALFORM">
<h5>for formulae: </h5>
<ul>
<li>
<xsl:value-of select="."/>
</li>
</ul>
</xsl:for-each>

<xsl:for-each select="NODECONTENT/REWORDER">
<h5>Rewriteorder for rules in intermediate steps: </h5>
<ul>
<li>
<xsl:value-of select="."/>
</li>
</ul>
</xsl:for-each>

<hr></hr>

<xsl:for-each select="NODECONTENT/SCRIPT">
<h5>Script: </h5>
</xsl:for-each>

<xsl:for-each select="NODECONTENT/SCRIPT/MATHML/ISA">
  <xsl:call-template name="insert_with_line_breaks">
    <xsl:with-param name="text" select="."/>
  </xsl:call-template>
<br></br>
</xsl:for-each>

  <hr></hr>
  <div class="context">
  <h5>Guard: </h5>

<table style="text-align: left; width: 100%;" border="1" cellspacing="0"
 cellpadding="2">
  <tbody>
  
<xsl:for-each select="NODECONTENT/GIVEN">  
<tr>
<td width="60">
<h5>Given: </h5>
</td>
<td> 
<xsl:for-each select="MATHML/ISA">
<xsl:value-of select="."/> <br></br>
</xsl:for-each>
<xsl:if test="not(MATHML/ISA)"><xsl:text>&nbsp;</xsl:text></xsl:if>
</td>
</tr>
</xsl:for-each>


<xsl:for-each select="NODECONTENT/WHERE">  
<tr>
<td>
<h5>Where: </h5>
</td>
<td>
<xsl:for-each select="MATHML/ISA">
<xsl:value-of select="."/> <br></br>
</xsl:for-each>
<xsl:if test="not(MATHML/ISA)"><xsl:text>&nbsp;</xsl:text></xsl:if>
</td>
</tr>
</xsl:for-each>

<xsl:for-each select="NODECONTENT/FIND">  
<tr>
<td>
<h5>Find: </h5>
</td>
<td>
<xsl:for-each select="MATHML/ISA">
<xsl:value-of select="."/> <br></br>
</xsl:for-each>
<xsl:if test="not(MATHML/ISA)"><xsl:text>&nbsp;</xsl:text></xsl:if>
</td>
</tr>
</xsl:for-each>

<xsl:for-each select="NODECONTENT/RELATE">  
<tr>
<td>
<h5>Relate: </h5>
</td>
<td>
<xsl:for-each select="MATHML/ISA">
<xsl:value-of select="."/> <br></br>
</xsl:for-each>
<xsl:if test="not(MATHML/ISA)"><xsl:text>&nbsp;</xsl:text></xsl:if>
</td>
</tr>
</xsl:for-each>

</tbody>
</table>

</div>
<hr></hr>

<xsl:for-each select="NODECONTENT/EXPLANATIONS">
<xsl:copy-of select="."/>
<br></br>
<br></br>
</xsl:for-each>

<hr></hr>


<xsl:for-each select="NODECONTENT/AUTHOR">
<hr>
</hr>
(c)
<xsl:value-of select="."/>
<br></br>
</xsl:for-each>

</body>

</html>

</xsl:template>

</xsl:stylesheet>
