<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">


<!--
  Call the template below to insert the content of a tag with
  replacement of newlines by <br> as following: 
  <xsl:call-template name="insert_with_line_breaks">
    <xsl:with-param name="text" select="TAG_TO_SELECT"/>
  </xsl:call-template>
-->
<xsl:template name="insert_with_line_breaks">
  <xsl:param name="text" select="."/>
  <xsl:choose>
  <xsl:when test="contains($text, '&#xa;')">
  	<xsl:value-of select="substring-before($text,'&#xa;')"/>
  	<br/>
  	<xsl:call-template name="insert_with_line_breaks">
  		<xsl:with-param name="text" select="substring-after($text,'&#xa;')"/>
  	</xsl:call-template>
  </xsl:when>
  <xsl:otherwise>
  	<xsl:value-of select="$text"/>
  </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template match="/">
<html>

<body>

<xsl:for-each select="NODECONTENT/EXPLANATIONS">
<xsl:copy-of select="."/>
<br></br>
</xsl:for-each>

<xsl:for-each select="NODECONTENT/AUTHOR">
<hr>
</hr>
<br></br>
(c)
<xsl:value-of select="."/>
<br></br>
</xsl:for-each>

<hr>
</hr>
</body>

</html>

</xsl:template>

</xsl:stylesheet>
