/*
 * @author Richard Gradischnegg
 * Created on Oct 9, 2003
 */
package isac.util.tactics;

import java.util.Iterator;
import java.util.Vector;

/**
 * @author Richard Gradischnegg
 */
public class StringListTactic extends Tactic {

  private Vector stringList = new Vector();

  public StringListTactic() {
  }

  public StringListTactic(String name) {
    this.name_ = name;
  }

  public StringListTactic(String name, Vector keyList) {
    this.name_ = name;
    this.stringList = keyList;
  }

  public void addKey(String key) {
    this.stringList.add(key);
  }

  public String toSMLString() {
    StringBuffer sb = new StringBuffer();
    sb.append(name_);
    if (stringList.size() > 0) {
      sb.append(" [");
      Iterator it = stringList.iterator();
      while (it.hasNext()) {
        sb.append("\"" + it.next() + "\",");
      }
      sb.deleteCharAt(sb.length() - 1); // remove last ","
      sb.append("]");
    }
    return sb.toString();
  }

}
