/*
 * @author Richard Rradischnegg
 * Created on Jun 25, 2004
 */
package isac.util.tactics;

import isac.util.formulae.Formula;

import java.io.Serializable;

/**
 * This is a helper class used by Rewrite Tactic and RewriteInst Tactic
 * 
 * @author Richard Rradischnegg
 */

public class Theorem implements Serializable {
    static final long serialVersionUID = -233677392264313623L;
	String id, formula;

    //Theorem consist of the ID, and
    //the formula (still as a string -- waiting for MathML)

    /**
     * Format the class to a string which can be used as SML-Input
     * 
     * @return
     */
    public String toSMLString() {
        return "(\"" + id + "\",\"\")"; //formula may be empty at input
    }

    public String getFormula() {
        return formula;
    }

    public String getId() {
        return id;
    }

    //WN060327 quick and dirty for XMLParserDigest
    public void setFormula(Formula form) {
        formula = form.toSMLString();
    }

    public void setFormula(String string) {
        formula = string;
    }

    public void setId(String string) {
        id = string;
    }

}