/*
 * Created on Nov 18, 2003
 */
package isac.wsdialog;

import isac.useractions.EUIElement;

/**
 * Exception thrown by the WorksheetDialog if the action requested by the user does
 * not match the state of the WorksheetDialog, e.g. specifying during the solving
 * phase.
 * 
 * @author Alan Krempler
 */
public class DialogProtocolException extends Exception {

  protected EUIElement failed_action_;

  protected int dialog_state_;

  DialogProtocolException(EUIElement failed_action, int dialog_state, String extra,
                          Throwable cause) {
    super("The WorksheetDialog cannot process a request.\n" + "Requested action: "
        + failed_action + ", Dialog state:"
        + String.valueOf(dialog_state) + ", " + extra);
    failed_action_ = failed_action;
    dialog_state_ = dialog_state;
  }

  DialogProtocolException(EUIElement failed_action, int dialog_state) {
    this(failed_action, dialog_state, null, null);
  }
}